import { __exports as stream } from '../../../../../../../_virtual/stream.mjs';
import require$$0 from 'node:stream';
import '../readers/stream.mjs';
import './provider.mjs';
import { __exports as stream$1 } from '../../../../../../../_virtual/stream2.mjs';
import { __exports as provider } from '../../../../../../../_virtual/provider.mjs';

Object.defineProperty(stream, "__esModule", {
  value: true
});
const stream_1 = require$$0;
const stream_2 = stream$1;
const provider_1 = provider;
class ProviderStream extends provider_1.default {
  constructor() {
    super(...arguments);
    this._reader = new stream_2.default(this._settings);
  }
  read(task) {
    const root = this._getRootDirectory(task);
    const options = this._getReaderOptions(task);
    const source = this.api(root, task, options);
    const destination = new stream_1.Readable({
      objectMode: true,
      read: () => {}
    });
    source.once('error', error => destination.emit('error', error)).on('data', entry => destination.emit('data', options.transform(entry))).once('end', () => destination.emit('end'));
    destination.once('close', () => source.destroy());
    return destination;
  }
  api(root, task, options) {
    if (task.dynamic) {
      return this._reader.dynamic(root, options);
    }
    return this._reader.static(task.patterns, options);
  }
}
stream.default = ProviderStream;
